# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   Python1
# FileName:      request_method.py
# Author:       chenyao
# Datetime:     2025/3/12 21:48
# Description:
# 
# ---------------------------------------------------------------------------
from time import sleep

import requests

from Auto_TestV4 import log_decorator
from Auto_TestV4.commom.db import DB
from Auto_TestV4.commom.read_excel import ReadExcel



class RequestMethod:
    @log_decorator
    def __init__(self):
        self.db=DB()
        self.bpm_session=requests.sessions.Session()
        login_url="http://36.139.193.99:8088/auth"
        login_data={"username":"admin","password":"f3lQcxTepVVR+2ykUc1s3nXGrn7fZWhPyfUW6PxhPr1piAFXSukfUbwHEmeJsPrJ2sJKw0hHqh8PsEqFOb+K35FnU/kohDJ//fu0gCzGg/GGAzXN3Lwshby3eTHPLnUijhDJD2f6x/T5Cd2k/rKkqLDgrJ9SIPMxJBRbt7snjg4="}
        self.headers={"Authorization":"Bearer "+self.bpm_session.post(url=login_url,json=login_data).json().get("token")}
        self.bpm_session.headers.update(self.headers)
    @log_decorator
    def request_all_data(self,r_method,r_url,r_type,r_case,r_expect,r_sql,r_sql_type,r_upkey):
        if r_sql_type=="delete":
            self.db.delete_method(r_sql)
        elif r_sql_type=="select":
            value=self.db.select_method(r_sql)
            if r_upkey=="需要更新":
                r_case.replace("需要更新",value)
            elif isinstance(r_case,dict):
                r_case[r_upkey]=value

        elif r_sql_type=="select|delete" or r_sql_type=="delete|select":
            self.db.delete_method(r_sql["delete"])

            value=self.db.select_method(r_sql["select"])
            if r_upkey=="需要更新":
                r_case.replace("需要更新",value)
            elif isinstance(r_case,dict):
                r_case[r_upkey]=value

        if r_type=="application/json" or r_type=="json":
            self.bpm_session.headers["content-type"]="application/json"
            if isinstance(r_case,str):
                return self.bpm_session.request(method=r_method,url=r_url,data=r_case)
            elif isinstance(r_case,(dict,list)):
                return self.bpm_session.request(method=r_method,url=r_url,json=r_case)

        elif r_type=="application/x-www-form-urlencoded" or r_type=="x-www-form-urlencoded":
            if isinstance(r_case,(str,dict,list)):
                return self.bpm_session.request(method=r_method,url=r_url,data=r_case)

        elif r_type=="multipart/form-data" or r_type=="form-data":
            self.bpm_session.headers["content-type"]="multipart/form-data"
            return  requests.request(method=r_method,url=r_url,files=r_case,headers=self.headers)

        elif r_type=="query":
            if isinstance(r_case,str):
                r_url=r_url+"?"+r_case
                return self.bpm_session.request(method=r_method,url=r_url)
            elif isinstance(r_case,dict):
                return self.bpm_session.request(method=r_method,url=r_url,params=r_case)

        elif r_type is None:
            return self.bpm_session.request(method=r_method,url=r_url)

        elif r_type=="text/plain":
            self.bpm_session.headers["content-type"]="text/plain"
            return self.bpm_session.request(method=r_method,url=r_url,data=r_case)

        elif r_type=="query|json" or r_type=="json|query":
            query_data=r_case["query"]
            json_data=r_case["json"]
            if isinstance(query_data,str):
                r_url=r_url+"?"+r_case
                if isinstance(json_data,str):
                    return self.bpm_session.request(method=r_method,url=r_url,data=json_data)
                elif isinstance(json_data,(dict,list)):
                    return self.bpm_session.request(method=r_method, url=r_url,json=json_data)
            elif isinstance(query_data,(dict,list)):
                if isinstance(json_data,str):
                    return self.bpm_session.request(method=r_method,url=r_url,data=json_data,params=query_data)
                elif isinstance(json_data,(dict,list)):
                    return self.bpm_session.request(method=r_method, url=r_url,json=json_data,params=query_data)


        else:
            raise ValueError("传入媒体类型错误，请更改")







