# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   Python1
# FileName:      test_bpm.py
# Author:       chenyao
# Datetime:     2025/3/15 14:01
# Description:
# 
# ---------------------------------------------------------------------------
import pytest

from Auto_TestV4 import log_decorator
from Auto_TestV4.commom.read_excel import ReadExcel
from Auto_TestV4.request_method.request_method import RequestMethod

data=ReadExcel().get_all_data()

class Testbpm:
    @log_decorator
    @pytest.mark.parametrize("r_method,r_url,r_type,r_case,r_expect,r_s,r_st,r_uk",data)
    def test_bpm(self,req_fix,r_method,r_url,r_type,r_case,r_expect,r_s,r_st,r_uk):
       res= RequestMethod().request_all_data(r_method=r_method,r_url=r_url,r_type=r_type,r_case=r_case,r_expect=r_expect,r_sql=r_s,r_sql_type=r_st,r_upkey=r_uk)
       print(res)

       try:
           for key in r_expect:
               assert r_expect[key]==res.json().get(key)
       except Exception as e:
           raise AssertionError(f"断言失败,请求方法为：{r_method}, url:{r_url}, 媒体类型：{r_type}, 用例数据：{r_case}, 期望数据：{r_expect}, sql语句为：{r_s}, sql语句类型：{r_st}, 更新为key:{r_uk}")

